/*
	Basic Java Bean.
*/

package webwisdom.tango.beans;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import webwisdom.tango.structures.BeanHandle;
import webwisdom.tango.beans.BeanRegister;
import webwisdom.tango.beans.Pipe;
import java.applet.*;

public class TangoBean extends Component implements java.io.Serializable, PipeConnectListener
{
	public TangoBean()
	{
		super();
		setSize(40,40);
		
		if (Beans.isDesignTime()) {		    
		    setVisible(true);    
		} else {		    
		    setVisible(false); 
		    br = new BeanRegister(this);
		}		
	}

	public void paint(Graphics context)
	{
		context.setColor(componentColor);
		context.fill3DRect(0,0,getSize().width,getSize().height, true);
		context.setColor(textColor);
		context.drawString("Tango", 5, 25);
		context.setColor(componentColor);
	}	
	
	public void addNotify() {
       	
	    Component c;	    				
				
		if (!Beans.isDesignTime() && h == null) {
		
		    c = getParent();
		    
    		while (!(c instanceof Applet) && c != null) {
		    
	    	       System.out.println("Trying to find applet");
		           c = c.getParent();		    
    		}
		
	    	if (c != null) {
	    	    
		        System.out.println("Applet found");
		        masterContainer = (Applet) c;   		   
		        h = registerBean();
		    
    		} else {
		
    	    	System.out.println("Applet not found");
    	    	h = null;
	        }		             
	    }
	    
        super.addNotify();        
    }
    
    public void removeNotify() {
        
        System.out.println("tango bean : component has been removed");  
        if (h != null) {
            
            h.remove();   
            
        }
        super.removeNotify();
    }
	
	 
	public synchronized void pipeReady(PipeConnectEvent cre) {
        
       Pipe pp = (Pipe) cre.getSource();        
       pp.setControl(id, this);
       tango_listeners.put(new Integer(id), pp);            
       id ++;            
    } 

    public void sendToTango(int channelID, Object toTango) {

        System.out.println("tango bean : message sent to tango");
        
        if(h != null) {
            
            h.putMessage(encode(channelID, toTango));
            
        } else {
            
            receiveFromTango(encode(channelID, toTango));               
            
        }
    }
    
    public void receiveFromTango(byte data[]) {
        
        System.out.println("tango bean: message received from tango");
        
	Object content[];			
        Pipe pp;        
	
	content = decode(data);
	
        pp = (Pipe) tango_listeners.get(content[0]);
        pp.receiveData(content[1]);                
    }
    
    public void receiveControlFromTango(byte data[]) {
        
        System.out.println("tango bean: control message received from tango");
                          
    }

    	
    private BeanHandle registerBean() {  	                
        
    	if (!Beans.isDesignTime()) {	
	      h = br.registerBean(masterContainer, this);	
	      return h;  
	    } else {
	        
	        return null;   
	    }
    }		
    	
	private Color componentColor = Color.yellow;
	private Color textColor = Color.black;
    private BeanHandle h = null;
    private BeanRegister br = null;
    private Applet masterContainer = null;
    private Hashtable tango_listeners = new Hashtable();
    private int id = 0;     


     private byte[] encode(int id, Object obj) {

            ByteArrayOutputStream baos;
            ObjectOutputStream oos;

            try {

            baos = new ByteArrayOutputStream();
                oos = new ObjectOutputStream(baos);
		oos.writeInt(id);
                oos.writeObject(obj);

            } catch(Exception e) {

            e.printStackTrace();
            baos = null;
	    return null;
            }

            return baos.toByteArray();

        }

        private Object[] decode(byte table[]) {

            ByteArrayInputStream bais;
            ObjectInputStream ois;
            Object result[] = new Object[2];
	    Object data;
            int id;
	 

            try {
            bais = new ByteArrayInputStream(table);
                ois = new ObjectInputStream(bais);
	
		id = ois.readInt();
		data = ois.readObject();
				
		result[0] = new Integer(id);
		result[1] = data;
	
	      } catch(Exception e) {

            e.printStackTrace();	    
            return null;
        }


           return result;
        }


}
